<?php
/**
	 Bluetooth Setup View File
	
	 @Copyright 2016 Stefan Rick
	 @author Stefan Rick
	 Mail: stefan@rick-software.de
 	 Web: http://www.netzberater.de
	
 */ 
?>											


<h1 class="entry-header">
	<?php echo _t("Bluetooth Setup Page") ?>
</h1>
<div class="entry-content">
	<?php if(isset($bt->view->message[0])){ ?>
		<div class="ui-widget">
			<div class="ui-state-highlight ui-corner-all" style="margin-bottom: 10px; padding: 0.4em .7em;">
				<p>
					<span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
					<?php echo implode('<br />', $bt->view->message); ?>					
				</p>
			</div>
		</div>
	<?php } ?>		
	<?php if($service->info->boardname == "Raspberry PI 3" ){ echo _t("You are using a Raspberry Pi 3. When your Bluetooth connection drops even if everything else looks fine (connected and green) this might be related to the build-in bluetooth chip on the Raspberry. Click on 'Reset Bluetooth Device' on this page to see if this causes the Error! More Info on this RPI-3 Bug: https://www.raspberrypi.org/forums/viewtopic.php?f=28&t=174747.").'</br></br>'; } ?>
	
	<?php echo _t("Having Problems? Follow the discussion here");?>:<br /><a href=http://www.max2play.com/forums/topic/bluetooth-addon-beta/ target="_blank">http://www.max2play.com/forums/topic/bluetooth-addon-beta/</a>
	<br /><br />
	
	<?php echo _t("On this page you can easily install Bluetooth support and connect this device to your Bluetooth-Speakers. After installing Bluetooth you have to assign the soundcard <i>Bluetoothspeaker</i> or <i>Pulse</i> to your audioplayers. Do this on the Audioplayer page in advanced settings.");?>
	<?php echo _t("<b>Important:</b> When using Squeezelite with Bluetooth Speakers remove '-C 5' Parameter from Commandline Options and add '-B' to sychronize Squeezelite with the Bluetooth Speaker connection (On/Off).");?><br />
	<br />
	<?php echo _t("To make sure your Speakers are reconnecting automatically on reboot, first start this device and then power up your Bluetooth speakers. This Addon is also working with the Addon Multisqueeze (running multiple audioplayers on one device).");?><br />
	<br />
	<?php echo _t("<b>The second option</b>: Streaming audio via Bluetooth from your smartphone to this player OR to the installed Squeezebox Server can be configured at the bottom of this page.");?><br />	
	<a href="https://www.max2play.com/en/portfolio/plugin-bluetooth-2/#fitvid417330" target=blank><?php echo _t("Watch a video tutorial on pairing and streaming from smartphone to Max2Play (Squeezebox Server)."); ?></a> <br />
	<br />
	
	<?php 
		if($bt->btaudio == 'pulse'){ ?>			
			<?php echo _t("<b>Important:</b> the Bluetooth speakers should connect automatically after the first pairing, if the speakers are active. You should always <b>enable Autostart</b>! This sets the correct sound-output for the speakers after they are connected. Click on <i>DEBUG</i> at the bottom of this page to see the connected and active devices.<br />When your BT-Speakers are immediately disconnecting on first setup, try to Power OFF the BT-Speakers, wait for 10 seconds and Power ON again. This should automatically connect them.");?><br />
		<?php }elseif (isset($bt->info->linux[1]) && $bt->info->linux[0] == "Debian") { ?>
			<?php echo _t("<b>Important:</b> You might need to restart your Audioplayer after connecting your speakers! A new Max2Play-Image is available for the Raspberry Pi as download. This automatically connects to the Bluetooth-Speakers on Boot and you don't need to restart your audioplayers."); 
		} ?>
		
	<br /><br />	
	<form action="" method="post" id="btform">
		<input type="hidden" id="action" name="action" value="" />		
		
	<?php if(!$bt->view->installed) { ?>
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
				<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
				<b><?php echo _t("Install Bluetooth support on this device") ?></b></p>
				<input type="button" id="install" name="install" onclick="document.getElementById('action').value='install';document.getElementById('btform').method='get';submit();" value="<?php echo _t("Install Bluetooth") ?>" />
		<br /><br />				
	<?php }else{ ?>
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
				<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
				<b><?php echo _t("Bluetooth is installed"); ?></b></p>				
							
		<?php echo _t("Important: Before Scanning, enable the Bluetooth Connection on your Speakers (make them visible for searching)!");?>
		<input type="button" value="<?php echo _t('Scan for Bluetooth Devices') ?>" name="scan" onclick="document.getElementById('action').value='scan';submit();" />
		<br /><br />
		
		<?php if ($bt->view->scandevices) { ?>		
			<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
				<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
				<b><?php echo _t("Bluetooth pairing") ?></b></p>
			<?php echo _t("Following Bluetooth Devices found:");?>
			<?php foreach($bt->view->scandevices as $device) { ?>
				<?php echo $device['name']?> <?php echo $device['address']?> <input type="button" value="<?php echo _t('Connect') ?>" name="connect" onclick="document.getElementById('action').value='connect_<?php echo $device['address'].'_'.urlencode($device['name']) ?>';submit();" /><br />
			<?php } ?>				
		<?php  } ?>
		
		<?php if ($bt->view->connecteddevices) { ?>		
			<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
				<span class="ui-icon ui-icon-signal-diag" style="float:left; margin:-2px 5px 0 0;"></span>
				<b><?php echo _t("Known Devices") ?></b></p>
			<?php echo _t("Following Bluetooth Speakers are known:");?><br /><br />
			<?php foreach($bt->view->connecteddevices as $device) { ?>
				<b <?php if($device['connected'])echo "style='color:green;' title='connected'"; else echo "style='color:red;' title='disconnected'"; ?>><?php echo $device['name']?></b> (<?php echo $device['address']?>) 
				<div style="float:right">
				  <input type="button" value="<?php echo _t('Connect') ?>" name="reconnect" onclick="document.getElementById('action').value='connect_<?php echo $device['address'].'_'.urlencode($device['name']) ?>';submit();" />
				  &nbsp;<input type="button" value="<?php echo _t('Disconnect') ?>" name="connect" onclick="document.getElementById('action').value='disconnect_<?php echo $device['address'].'_'.urlencode($device['name']) ?>';submit();" />
				  &nbsp;<input type="button" value="<?php echo _t('Remove') ?>" name="remove" onclick="document.getElementById('action').value='remove_<?php echo $device['address'].'_'.urlencode($device['name']) ?>';submit();" />
				</div>
				<div style="clear:both;border-top: 1px solid aliceblue;padding: 1px;"> </div>
			<?php } ?>
		<?php  } ?>
		
		<?php if($bt->btaudio != 'bluealsa'){ //Not for Debian Stretch withouth Pulse! ?>
    		<br /><br />    		
    		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
    				<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
    				<b><?php echo _t("Options for Steaming Audio to Bluetooth Speakers") ?></b></p>
    		<div id="settings" class="optiondetails">
    			<table>
    				<tr>
    					<td><?php echo str_replace('$SERVICENAME', $bt->viewname, _('Autostart $SERVICENAME')) ?></td>	
    		 			<td><input type="checkbox" <?php if($bt->view->autostart) echo "checked"; ?> value="1" name="autostart" /></td>
    		 			<td><?php echo _t('Autostart on Boot (on Jessie starts X-Server) and automatically reconnect to BT-Speakers, once available.')?></td>
    		 		</tr>
    			<?php if($bt->btaudio == 'pulse'){ ?>	
    				<tr>
    					<td><?php echo _t('Switch audio output on disconnect') ?></td>  
    					<td><input type="checkbox" <?php if($bt->pulsesettings['module-rescue-streams']) echo "checked"; ?> value="1" name="module-rescue-streams" /></td>
    					<td><?php echo _t('If enabled and your Bluetooth-Speakers disconnect, the Audio will be sent to the next available audiocard.') ?></td>
    				</tr>
    				<tr>
    					<td><?php echo _t('Squeezelite Bluetooth Connection Sync') ?></td>  
    					<td><input type="button" value="<?php echo _t("Install") ?>" onclick="document.getElementById('action').value='squeezelitebluetooth';submit();" /></td>
    					<td><?php echo _t('After installation you can link the Audioplayer Squeezelite Power-Status with the connection status of your choosen Bluetooth Speakers (click "reconnect" to select). <b>Important: Add "-B" to the command line options</b> of your Squeezelite player (on Audioplayer Tab or in Multisqueeze for the instance that uses the BT-Speakers).') ?></td>
    				</tr>
    			<?php } ?>
    			</table>
    			<input type="button" value="<?php echo _('save') ?>" name="save" onclick="document.getElementById('action').value='save';submit();" />
    		</div>		
		<?php } ?>
		
		<br /><br />
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-circle-close" style="float:left; margin:-2px 5px 0 0;"></span>
			<b><?php echo _t("Uninstall Bluetooth") ?></b></p>
		<input type="button" id="uninstall" name="uninstall" onclick="document.getElementById('action').value='uninstall';submit();" value="<?php echo _t("Uninstall Bluetooth") ?>" />&nbsp;&nbsp;
		<input type="button" id="resetbluetoothdevice" name="resetbluetoothdevice" onclick="document.getElementById('action').value='resetbluetoothdevice';submit();" value="<?php echo _t("Reset Bluetooth Device") ?>" title="<?php echo _t("If Bluetooth hangs even if everything seems OK. This might be related to Build-In Bluetooth Chip on RPI-3.") ?>" />	
	<?php }?>
	
	
	<br /><br />
	<?php echo _t("This addon is tested with Raspberry Pi 2 and Bluetooth dongles as well as Raspberry Pi 3 build-in Bluetooth. Kodi and Audioplayers (Squeezelite and Shairport) can simultanously connect to the Bluetooth-Speakers.");?><br />
	<br /><br />
	<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-signal-diag" style="float:left; margin:-2px 5px 0 0;"></span>
			<b><?php echo _t("Stream Audio to Max2Play OR Squeezebox Server with Bluetooth") ?></b></p>	
	<?php echo _t("It is possible to connect a Bluetooth Device (e.g. your smartphone) and <b>stream audio</b> to the soundcard of the Max2Play device OR to the Squeezebox Server!");?><br />
			 <br>	
	<?php echo _t("First step is always to connect to your smartphone. This must be done just once. After the initial setup your smartphone can connect anytime to Max2Play by choosing the existing bluetooth connection.<br>Scan for devices on this page (make sure your smartphone is discovering bluetooth devices) and click the reconnect button next to your smartphone. A popup will open on your smartphone to establish the connection and the connection status should be indicated as green and connected on this page.");?><br />
			 <br />
	<?php echo _t("Choose your streaming Setup:")?> 
	<div id="tabs-min">
		  <ul>
		    <li><a href="#tabs-1"><?php echo _t('Stream directly to Max2Play Soundcard') ?></a></li>
		    <li><a href="#tabs-2"><?php echo _t('Stream to Squeezebox Server') ?></a></li>	    
		  </ul>
		  <div id="tabs-1">
		    <p>		    	
		    	<?php if($bt->btaudio == 'bluealsa'){ ?>
		    		<?php echo _t("With this setup you may stream audio directly to the Max2Play Device (Raspberry Pi) without using the Squeezebox Server. You can specify the Audio Card and further settings for the direct streaming below."); ?>
		    		<br /><br />
		    		<?php if ($bt->view->bt_speaker_status) { ?>
						<b><?php echo _('Status') ?>:</b> <?php echo str_replace('$SERVICENAME', $bt->view->bt_speaker_viewname, _('$SERVICENAME is running with processID')) ?> <b><?php echo $bt->view->bt_speaker_status ?></b>
						<input type="button" value="<?php echo str_replace('$SERVICENAME', $bt->view->bt_speaker_viewname, _('stop $SERVICENAME')) ?>" name="stop_btspeaker" onclick="document.getElementById('action').value='stop_btspeaker';submit();" />            		
            		<?php }else { ?>
            			<b><?php echo _('Status') ?>:</b> <?php echo str_replace('$SERVICENAME', $bt->view->bt_speaker_viewname, _('$SERVICENAME not running')) ?>
            		    <input type="button" value="<?php echo str_replace('$SERVICENAME', $bt->view->bt_speaker_viewname, _('start $SERVICENAME')) ?>" name="start_btspeaker" onclick="document.getElementById('action').value='start_btspeaker';submit();" />	
            		<?php } ?>
            		<br />
		    		<table>        				
        				<tr>
        					<td><?php echo _t('Autostart '.$bt->view->bt_speaker_viewname) ?></td>					
        					<td><input type="checkbox" <?php if($bt->view->autostart_bt_speaker) echo "checked"; ?> value="1" name="autostart_bt_speaker" /></td>
        					<td><?php echo _t('Bluetooth-Speaker is a small program needed for streaming (e.g. from your smartphone) to Max2Play. Leave this on Autostart if you want to use direct streaming.') ?></td>
        				</tr>
        				<tr>
        					<td><?php echo _t('Sound Device') ?></td>
        					<td>        						
        						<select name="btspeaker_device" style="width: 90%;" >
        						<?php foreach($bt->view->soundDevices as $position => $soundDevice){ ?>
        							<option <?php if($bt->view->btspeakerconfig_position == $position) echo 'selected'; ?> value='<?php echo $position ?>'><?php echo $soundDevice['name'].' - hw:'.$soundDevice['card'].':'.$soundDevice['device'].' - Mixer '.$soundDevice['mixer_control'].' - '.$soundDevice['description']; ?></option>
        						<?php }?>
        						</select>
        					</td>
        					<td><?php echo _t('The Sound Device used as Output. If you have other audioplayers (squeezelite / shairport / MPD / Kodi) running, make sure the audiocard is not blocked!') ?></td>
        				</tr>
        			</table>
        		    <br /><br />
        		    <a class="button-small clickloading" href="#" onclick="document.getElementById('action').value='save_btspeaker';$('#btform').submit();"><?php echo _("Save!") ?></a>
		    		<br /><br />		    		
		    		
		    	<?php }else {  /* Debian Jessie with Pulseaudio... */ ?>
		    		<?php echo _t("With this setup you may stream audio directly to the Max2Play Device (Raspberry Pi) without using the Squeezebox Server. This setting requires to <b>have all audioplayers playing with 'pulse' as soundcard</b> - otherwise no audio will play! You must change this in the advanced settings of Squeezelite on Audioplayer tab.") ?><br />
		    		<?php echo _t("Important for sound card users (e.g. HifiBerry, IQAudIO, Justboom): If you have an active dedicated sound card on your Pi, make sure to <ul class='description'><li>deactivate integrated audio on your Raspberry on the Raspberry Settings Page,</li><li>delete all parameters in the Command Line Options of Audio Players in their Advanced Options as these might override soundcard settings.</li></ul>") ?><br />		    	
		    	<?php } ?>
		 	</p>
		  </div>
		  <div id="tabs-2">
		    <p>		     
		      <?php echo _t('Setting up Squeezebox Server to stream audio via Bluetooth to multiple connected players is easy too. This only works for the Squeezebox Server running on this device! Make sure to have your smartphone connected successfully and click the install button below. <br />Afterwards, you see the "Bluetooth-Player" in your Squeezebox Server favorites and it will play automatically when you start streaming from a Bluetooth device and switch back once finished streaming!');?>
			  <br />
			  <?php if(!$bt->view->installed) { ?>
			  	<br />
			  	<b><?php echo _t('Bluetooth support is not installed yet! First install Bluetooth on this page and then set up Squeezebox Server to use Bluetooth as Audio Input!') ?></b>
			  <?php }else{ ?>
			  	<?php if($bt->btaudio == 'bluealsa') { ?>
			  				  		
    			  	<input type="button" value="<?php echo _t("Install Bluetooth Steaming for Squeezebox Server") ?>" name="installbluetoothalsasbs" onclick="document.getElementById('action').value='installbluetoothalsasbs';submit();" /><br />
    			  	<br />
    			  	
    			  	<div id="settingsalsabt" class="optiondetails">
    					<table>
    						<tr>
    							<td><?php echo _t('Autostart Bluetooth-Streaming in Squeezebox Server'); ?></td>	
    				 			<td><input type="checkbox" <?php if($bt->view->ALSABLUETOOTH_AUTOSTART_SBS) echo "checked"; ?> value="1" name="ALSABLUETOOTH_AUTOSTART_SBS" /></td>
    				 			<td><?php echo _t('Autostart streaming in Squeezebox Server when connected Bluetooth Device starts streaming audio.')?></td>
    				 		</tr>
    				 		<tr>
    							<td><?php echo _t('Player MAC-Address for Autostart (optional)'); ?></td>	
    				 			<td><input type="text" value="<?php echo $bt->view->BLUETOOTH_MACADDRESS_MAINPLAYER; ?>" name="BLUETOOTH_MACADDRESS_MAINPLAYER" /></td>
    				 			<td><?php echo str_replace('$MACADDRESS',$bt->view->hwaddress, _t('Choose the Player to automatically start playing, once Bluetooth starts streaming audio. You may synchronize other players to this one. MAC address example (this device): $MACADDRESS')) ?></td>
    				 		</tr>
    				 		<tr>
    							<td><?php echo _t('Enable Debug-Mode (optional)'); ?></td>	
    				 			<td><input type="checkbox" <?php if($bt->view->ALSABLUETOOTH_DEBUG) echo "checked"; ?> value="1" name="ALSABLUETOOTH_DEBUG" /></td>
    				 			<td><?php echo _t('Add detailled Debug output for Bluetooth automatic switch for Squeezebox Server. Restart needed after changing this!')?></td>
    				 		</tr>
    				  	</table>
    				  	<br />
    				  	<input type="button" value="<?php echo _('save') ?>" name="savealsasbs" onclick="document.getElementById('action').value='savealsasbs';submit();" />
    				  	<br />
    		 		</div>
			  	
			  	
			  	<?php } else { ?>
    			  	<?php echo _t('The first Setup has to be done once for every Smartphone:');?><br />
    			  	<input type="button" value="<?php echo _t("Install Bluetooth Steaming for Squeezebox Server") ?>" name="install2" onclick="document.getElementById('action').value='installbluetoothsbs';submit();" /><br />
    			  	<br />
    			  	
    			  	<div id="settingspulsebt" class="optiondetails">
    					<table>
    						<tr>
    							<td><?php echo _t('Autostart Bluetooth-Streaming in Squeezebox Server'); ?></td>	
    				 			<td><input type="checkbox" <?php if($bt->view->PLUSEBLUETOOTH_AUTOSTART_SBS) echo "checked"; ?> value="1" name="PLUSEBLUETOOTH_AUTOSTART_SBS" /></td>
    				 			<td><?php echo _t('Autostart streaming in Squeezebox Server when connected Bluetooth Device starts streaming audio.')?></td>
    				 		</tr>
    				 		<tr>
    							<td><?php echo _t('Player MAC-Address for Autostart (optional)'); ?></td>	
    				 			<td><input type="text" value="<?php echo $bt->view->BLUETOOTH_MACADDRESS_MAINPLAYER; ?>" name="BLUETOOTH_MACADDRESS_MAINPLAYER" /></td>
    				 			<td><?php echo str_replace('$MACADDRESS',$bt->view->hwaddress, _t('Choose the Player to automatically start playing, once Bluetooth starts streaming audio. You may synchronize other players to this one. MAC address example (this device): $MACADDRESS')) ?></td>
    				 		</tr>
    				 		<tr>
    							<td><?php echo _t('Enable Debug-Mode (optional)'); ?></td>	
    				 			<td><input type="checkbox" <?php if($bt->view->PLUSEBLUETOOTH_DEBUG) echo "checked"; ?> value="1" name="PLUSEBLUETOOTH_DEBUG" /></td>
    				 			<td><?php echo _t('Add detailled Debug output for Pulsebluetooth automatic switch for Squeezebox Server. Restart needed after changing this!')?></td>
    				 		</tr>
    				  	</table>
    				  	<br />
    				  	<input type="button" value="<?php echo _('save') ?>" name="save" onclick="document.getElementById('action').value='save';submit();" />
    				  	<br />
    		 		</div>
		 		<?php }?>
			  <?php }?>
   
		    </p>
		  </div>	  
	</div>
	
	<script>
	 $(function() {
	   $( "#tabs-min" ).tabs();
	 });
	</script>
	
	</form>						
	
	<br /><br />
	<a href="#javascript" onclick="document.getElementById('debug').style.display='';return false;"><?php echo _("DEBUG Informations") ?></a><br />
	<textarea id="debug" rows="30" cols="70" style="display:none;"><?php foreach ($bt->view->debug as $key => $debug) {
			echo "#### ". $key. " ####\n"; 
			 echo $debug." \n\n"; 
		 }?>
	</textarea>
</div>	